
typedef struct Dictionary Dictionary;

Dictionary *dictionary_new(collectionisequal isequal, collectionhash hash);

void dictionary_free(Dictionary *self);

void dictionary_free_with(Dictionary *self, 
  functionunary free_key, functionunary free_value);

/** returns true if it was added, false if it exists and value was updated */
bool dictionary_add(Dictionary *self, void *key, void *value);

bool dictionary_remove(Dictionary *self, void *key);

void *dictionary_at(Dictionary *self, void *key);

bool dictionary_get_key_value(Dictionary *self, void **key, void **value);

bool dictionary_get(Dictionary *self, void *key, void **value);

bool dictionary_includes(Dictionary *self, void *key);

uint dictionary_size(Dictionary *self);


