
typedef struct FileHandle FileHandle;
typedef struct DirectoryHandle DirectoryHandle;
typedef struct SingleFileHandle SingleFileHandle;


void filehandle_free(FileHandle *self);
void filehandle_read(FileHandle *self, Req *request, HoleManager *holemanager);
void filehandle_write(FileHandle *self, Req *request);
void filehandle_close(FileHandle *self);

SingleFileHandle *singlefilehandle_open(int fd);

DirectoryHandle *directoryhandle_new(char *path);
uint directoryhandle_count(DirectoryHandle *self);
void directoryhandle_add(DirectoryHandle *self, Rule *rule, int fd);


