
enum { FS_READ_BUFFER_MAX = 8192 };

#define return_9p_response(reason) \
  respond(request, (reason)); \
  return

#define return_9p_error(reason) \
  respond(request, (reason)); \
  return

#define return_9p_error_if(exp, reason) \
  if(exp) { return_9p_error(reason); }

#define return_9p_success() \
  respond(request, nil); \
  return


typedef struct Matcher Matcher;

typedef struct Setting Setting;


Setting *setting_new(char *rulefile, char *mountpoint, char *holefile);
Setting *setting_default_path_new(
  char *defaultpath, char *rulefile, char *mountpoint, char *holefile);

/** starts fs */
void fs_start(Setting *setting);

/** enable 9p srv debugging messages */
void fs_native_9p_debug_enable(void);

