#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>
#include "common.h"
#include "utils.h"

void *emallocz9p(ulong size)
{
  void *result = emalloc9p(size);
  return memset(result, 0, size);
}

void *emalloc_fs(ulong size)
{
  return emalloc9p(size);
}

void *erealloc_fs(void *p, ulong size)
{
  return erealloc9p(p, size);
}

void *emallocz_fs(ulong size)
{
  return emallocz9p(size);
}

char *estrdup_fs(char *str)
{
  return estrdup9p(str);
}


